package io.xjar.dir;

import java.io.IOException;
import io.xjar.key.XKey;
import io.xjar.XEntryFilter;
import io.xjar.XDecryptor;
import java.io.File;
import io.xjar.XEntryDecryptor;

public class XDirDecryptor extends XEntryDecryptor<File> implements XDecryptor
{
    public XDirDecryptor(final XDecryptor xDecryptor) {
        this(xDecryptor, null);
    }
    
    public XDirDecryptor(final XDecryptor xDecryptor, final XEntryFilter<File> filter) {
        super(xDecryptor, (XEntryFilter)filter);
    }
    
    public void decrypt(final XKey key, final File src, final File dest) throws IOException {
        if (src.isFile()) {
            final XDecryptor decryptor = (XDecryptor)(this.filtrate((Object)src) ? this.xDecryptor : this.xNopDecryptor);
            decryptor.decrypt(key, src, dest);
        }
        else if (src.isDirectory()) {
            final File[] files = src.listFiles();
            for (int i = 0; files != null && i < files.length; ++i) {
                this.decrypt(key, files[i], new File(dest, files[i].getName()));
            }
        }
    }
}
